ElementScanner8 (Java SE 10 & JDK 10 )
Keywords: javax.lang.model.util.ElementScanner8 class

Module java.compiler
Package javax.lang.model.util

## Class ElementScanner8<R,P>

- java.lang.Object
- - javax.lang.model.util.AbstractElementVisitor6<R,P>
  - - javax.lang.model.util.ElementScanner6<R,P>
    - - javax.lang.model.util.ElementScanner7<R,P>
      - - javax.lang.model.util.ElementScanner8<R,P>

- Type Parameters:
    `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
    `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.
  All Implemented Interfaces:
    `ElementVisitor<R,P>`
  Direct Known Subclasses:
    `ElementScanner9`

      @SupportedSourceVersion(RELEASE_8)
      public class ElementScanner8<R,P>
      extends ElementScanner7<R,P>

  A scanning visitor of program elements with default behavior appropriate for the `RELEASE_8` source version. The `visitXyz` methods in this class scan their component elements by calling `scan` on their enclosed elements, parameters, etc., as indicated in the individual method specifications. A subclass can control the order elements are visited by overriding the `visitXyz` methods. Note that clients of a scanner may get the desired behavior be invoking `v.scan(e, p)` rather than `v.visit(e, p)` on the root objects of interest.

  When a subclass overrides a `visitXyz` method, the new method can cause the enclosed elements to be scanned in the default way by calling `super.visitXyz`. In this fashion, the concrete visitor can control the ordering of traversal over the component elements with respect to the additional processing; for example, consistently calling `super.visitXyz` at the start of the overridden methods will yield a preorder traversal, etc. If the component elements should be traversed in some other order, instead of calling `super.visitXyz`, an overriding visit method should call `scan` with the elements in the desired order.

  Methods in this class may be overridden subject to their general contract. Note that annotating methods in concrete subclasses with `@Override` will help ensure that methods are overridden as intended.

  WARNING: The `ElementVisitor` interface implemented by this class may have methods added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes which extend this class should not declare any instance methods with names beginning with `"visit"`.

  When such a new visit method is added, the default implementation in this class will be to call the `visitUnknown` method. A new element scanner visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When the new visitor is introduced, all or portions of this visitor may be deprecated.

  Since:
    1.8
  See Also:
    `ElementScanner6`, `ElementScanner7`, `ElementScanner9`

- - ### Field Summary

    - ### Fields declared in class javax.lang.model.util.ElementScanner6

      `DEFAULT_VALUE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `ElementScanner8()` | Constructor for concrete subclasses; uses `null` for the default value.
    `protected` | `ElementScanner8​(R defaultValue)` | Constructor for concrete subclasses; uses the argument for the default value.

  - ### Method Summary

    - ### Methods declared in class javax.lang.model.util.AbstractElementVisitor6

      `visit, visit, visitModule, visitUnknown`

    - ### Methods declared in class javax.lang.model.util.ElementScanner6

      `scan, scan, scan, visitExecutable, visitPackage, visitType, visitTypeParameter`

    - ### Methods declared in class javax.lang.model.util.ElementScanner7

      `visitVariable`

    - ### Methods declared in class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ElementScanner8

          protected ElementScanner8()

      Constructor for concrete subclasses; uses `null` for the default value.

    - #### ElementScanner8

          protected ElementScanner8​(R defaultValue)

      Constructor for concrete subclasses; uses the argument for the default value.
      Parameters:
        `defaultValue` - the default value